/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */

#define BLK_SIZE 4096

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
char *slurp_file(char *filename, int *filelen)
{
	FILE	*fp;
	char 	*query_string;

	int 	total_read, 
		len, 
		max_len,
		bytes_read;


	fp = fopen(filename, "rb");
	if (fp == NULL)
	{
		fprintf(stderr, "Error: opening file\n");
		exit(1);
	}


	query_string = (char *)malloc(sizeof(char) * (BLK_SIZE +1));
	if (query_string == NULL)
	{
		return NULL;
	}


	total_read = 0;
	len        = BLK_SIZE;
	max_len    = BLK_SIZE;

	bytes_read = fread(&query_string[total_read], 1, len, fp);
	while(bytes_read != 0)
	{	
		len        -= bytes_read;
		total_read += bytes_read;

		if (len == 0)
		{	
			query_string = (char *)realloc(query_string, sizeof(char) * (max_len + BLK_SIZE +1));
			if (query_string == NULL)
			{	return NULL;
			}

			len      = BLK_SIZE;
			max_len += BLK_SIZE;
		}

		bytes_read = fread(&query_string[total_read], 1, len, fp);
	}

	if (!feof(fp))
	{
		return NULL;
	}

	fclose(fp);

	*filelen = total_read;
	return query_string;
}

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
int main(int argc, char **argv)
{
	char 	*res;
	int	len,
		i;


	if (argc != 2)
	{	fprintf(stderr, "Usage: %s <filename>\n", argv[0]);
		return 1;
	}


	res = slurp_file(argv[1], &len);
	for (i=0; i<len; i++)
	{	fputc(res[i], stdout);
	}


	free(res);	
	return 0;
}
